use std::error::Error;
use std::time::Duration;
use std::thread;

use rpi_embedded::uart::{Parity, Uart};

struct GpsData {
    id    : String,
    time  : String,
    lat   : String,
    long  : String,
    nbSat : String,
    hdop  : String,
    alti  : String,
}

struct GPS {
    baudrate : BaudRate,
}

pub enum BaudRate {
    Baud110,
    Baud300,
    Baud600,
    Baud1200,
    Baud2400,
    Baud4800,
    Baud9600,
    Baud19200,
    Baud38400,
    Baud57600,
    Baud115200,
    BaudOther(usize),
}

// pub enum UARTPort{

// }

enum id {
    GPGGA,
    GPGSA,
    GPGSV,
    GPRMC,
    GPVTG,
}


fn main() -> Result<(), Box<dyn Error>> {
    let gps = GPS {
        baudrate : BaudRate::Baud9600,
    };
    // Connect to the primary UART and configure it for 115.2 kbit/s, no
    // parity bit, 8 data bits and 1 stop bit.
    let mut uart = Uart::new(9600, Parity::None, 8, 1)?;

    // Configure read() to block until at least 1 byte is received.
    uart.set_read_mode(1, Duration::default())?;

    let mut buffer = [1u8; 1];
    // let mut vec_of_u8 = vec![0u8;100];
    let mut vec_of_u8 = Vec::new();
    println!("Start");
    loop {
        // Fill the buffer variable with any incoming data.
        if uart.read_bytes(&mut buffer)? > 0 {
            vec_of_u8.push(buffer[0]);
            // println!("Received byte: {}",vec_of_u8[i as usize] );
            // println!("Received byte: {}",buffer[0]);
            // thread::sleep(Duration::from_millis(20000));
            if (buffer[0] == 10){
                let string_utf8_result = String::from_utf8(vec_of_u8.clone()).unwrap();
                let tokens:Vec<&str>=string_utf8_result.split(",").collect();
                println!("New message : {:?}", string_utf8_result);
                if tokens[0] == "$GPGGA"{
                    let data = GpsData{
                        id    : tokens[0].to_string(),
                        time  : tokens[1].to_string(),
                        lat   : tokens[2].to_string(),
                        long  : tokens[4].to_string(),
                        nbSat : tokens[6].to_string(),
                        hdop  : tokens[7].to_string(),
                        alti  : tokens[8].to_string(),
                    };
                    // println!("lat : {}", data.lat);
                }   
                vec_of_u8 = vec![];
            }
        }
    }
    Ok(())
}
